if (! this.sh_languages) {
  this.sh_languages = {};
}
sh_languages['puppet'] = [
  [
    [
      /\b(?:require)\b/g,
      'sh_preproc',
      -1
    ],
    [
      /'?puppet:\/\/[A-Za-z0-9_\.\/\-_~]+(?:>?)'?/g,
      'sh_puppet_uri',
      -1
    ],
    [
      /\b[+-]?(?:(?:0x[A-Fa-f0-9]+)|(?:(?:[\d]*\.)?[\d]+(?:[eE][+-]?[\d]+)?))u?(?:(?:int(?:8|16|32|64))|L)?\b/g,
      'sh_number',
      -1
    ],
    [
      /"/g,
      'sh_string',
      1
    ],
    [
      /'/g,
      'sh_string',
      2
    ],
    [
      /</g,
      'sh_string',
      3
    ],
    [
      /\/[^\n]*\/\s/g,  // anchor to \s to avoid matching directory names.
      'sh_regexp',
      -1
    ],
    [
      /(%r)(\{(?:\\\}|#\{[A-Za-z0-9]+\}|[^}])*\})/g,
      ['sh_symbol', 'sh_regexp'],
      -1
    ],
    [
      /\b[A-Za-z0-9]+(?=\s*[=|\+]>)/g,
      'sh_attribute',
      -1
    ],
    [
      /=>|\+>/g,
      'sh_hashrocket',
      -1
    ],
    [
      /\b(?:class|define|node)\b/g,
      'sh_param',
      -1
    ],
    [
      /\b(?:present|absent|purged|latest|installed|running|stopped|mounted|unmounted|role|configured|file|directory|link)\b/g,
      'sh_ensure',
      -1
    ],
    [
      /[A-Z][A-Za-z0-9]+\[.*\]/g,
      'sh_reference',
      -1
    ],
    [
      /\b(?:alert|crit|debug|emerg|err|fail|include|info|notice|realize|require|search|tag|warning)\b/g,
      'sh_function',
      -1
    ],
    [
      /\b(?:defined|file|fqdn_rand|generate|inline_template|regsubst|sha1|shellquote|split|sprintf|tagged|template|versioncmp)\b/g,
      'sh_function',
      -1
    ],
    [
      /\b(?:true|false|undef|import|inherits|include|case|default|if|else|elsif)\b/g,
      'sh_keyword',
      -1
    ],
    [
      /(?:^\=begin)/g,
      'sh_comment',
      4
    ],
    [
      /(?:\$[#]?|@@|@)(?:[A-Za-z0-9_]+|'|\"|\/)/g,
      'sh_type',
      -1
    ],
    [
      /[A-Za-z0-9]+(?:\?|!)/g,
      'sh_normal',
      -1
    ],
    [
      /~|!|%|\^|\*|\(|\)|-|\+|=|\[|\]|\\|:|;|,|\.|\/|\?|&|<|>|\|/g,
      'sh_symbol',
      -1
    ],
    [
      /(#)(\{)/g,
      ['sh_symbol', 'sh_cbracket'],
      -1
    ],
    [
      /#/g,
      'sh_comment',
      1
    ],
    [
      /\{|\}/g,
      'sh_cbracket',
      -1
    ]
  ],
  [
    [
      /$/g,
      null,
      -2
    ],
    [
      /\\(?:\\|")/g,
      null,
      -1
    ],
    [
      /"/g,
      'sh_string',
      -2
    ]
  ],
  [
    [
      /$/g,
      null,
      -2
    ],
    [
      /\\(?:\\|')/g,
      null,
      -1
    ],
    [
      /'/g,
      'sh_string',
      -2
    ]
  ],
  [
    [
      /$/g,
      null,
      -2
    ],
    [
      />/g,
      'sh_string',
      -2
    ]
  ],
  [
    [
      /^(?:\=end)/g,
      'sh_comment',
      5
    ]
  ],
  [
    [
      /$/g,
      null,
      -2
    ]
  ]
];
